/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of ACL.xs. Do not edit this file, edit ACL.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "ACL.xs"
/*
Copyright 2013 Yuriy Nazarov.
This program is free software; you can redistribute it and/or modify it under the terms of either: the GNU General Public License as published by the Free Software Foundation; or the Artistic License.
*/
#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <sys/acl.h>
#include <errno.h>
#include <sys/stat.h>
#include <sys/acl.h>
#include <acl/libacl.h>
#ifdef __cplusplus
}
#endif

#define USER_KEY "user"
#define USER_KEY_LENGTH 4
#define GROUP_KEY "group"
#define GROUP_KEY_LENGTH 5
#define OTHER_KEY "other"
#define OTHER_KEY_LENGTH 5
#define MASK_KEY "mask"
#define MASK_KEY_LENGTH 4
#define USER_OBJ_KEY "uperm"
#define USER_OBJ_KEY_LENGTH 5
#define GROUP_OBJ_KEY "gperm"
#define GROUP_OBJ_KEY_LENGTH 5

#define CONSTANT_YES 0
#define CONSTANT_NO  1

HV* derefHV(SV *hashref){
	HV *ret_hash;
	if (! SvROK(hashref))	//check that input value is really reference
		return NULL;
	ret_hash = (HV *)SvRV(hashref);
	if (SvTYPE((SV *)ret_hash) != SVt_PVHV)	//check that it's really hash
		return NULL;
	return ret_hash;
}

void add_perm_to_hash(HV *hash, int r, int w, int x, char *key, U32 key_len){
	HV* perm_hash = newHV();

	hv_store(perm_hash, "r", 1, newSViv( r!=0 ), 0);
	hv_store(perm_hash, "w", 1, newSViv( w!=0 ), 0);
	hv_store(perm_hash, "x", 1, newSViv( x!=0 ), 0);

	hv_store(hash, key, key_len, newRV_noinc((SV*) perm_hash), 0);
}

void add_to_hash(HV *hash, acl_entry_t *ent, char *key, U32 key_len){
	acl_permset_t permset;
	
	acl_get_permset(*ent, &permset);
	add_perm_to_hash(hash, acl_get_perm(permset, ACL_READ), acl_get_perm(permset, ACL_WRITE), acl_get_perm(permset, ACL_EXECUTE), key, key_len);
}

void set_perm(acl_entry_t ent, mode_t perm)
{
	acl_permset_t set;

	acl_get_permset(ent, &set);
	if (perm & ACL_READ)
		acl_add_perm(set, ACL_READ);
	else
		acl_delete_perm(set, ACL_READ);
	if (perm & ACL_WRITE)
		acl_add_perm(set, ACL_WRITE);
	else
		acl_delete_perm(set, ACL_WRITE);
	if (perm & ACL_EXECUTE)
		acl_add_perm(set, ACL_EXECUTE);
	else
		acl_delete_perm(set, ACL_EXECUTE);
}

int get_perm_from_hash(HV *hash, const char *key, int key_len){
	HV *perm;
	SV **perm_ref;
	SV **atom_ref;
	int perm_val = 0;
	if(perm_ref = hv_fetch(hash, key, key_len, 0)){
		perm = derefHV(*perm_ref);
		if(NULL==perm){
			return 0;
		}

		if(atom_ref = hv_fetch(perm, "r", 1, 0)){
			if (! SvIOK(*atom_ref))
				return 0;
			perm_val |= SvIV(*atom_ref)?ACL_READ:0;
		}

		if(atom_ref = hv_fetch(perm, "w", 1, 0)){
			if (! SvIOK(*atom_ref))
				return 0;
			perm_val |= SvIV(*atom_ref)?ACL_WRITE:0;
		}

		if(atom_ref = hv_fetch(perm, "x", 1, 0)){
			if (! SvIOK(*atom_ref))
				return 0;
			perm_val |= SvIV(*atom_ref)?ACL_EXECUTE:0;
		}
	}
	return perm_val;
}

int getfacl_internal(char *filename, HV **out_acl, HV **out_default_acl){	//returns count
	struct stat st;
	int i;
	HV        **acl_hashes[2] = {out_acl,         out_default_acl};
	acl_type_t acl_types[2]   = {ACL_TYPE_ACCESS, ACL_TYPE_DEFAULT};
	*out_acl         = NULL;
	*out_default_acl = NULL;

	if (stat(filename, &st) != 0) {
		return 0;
	}
	
	for(i=0; i<2; i++){
		HV* acl_hash;
		HV* ret_acl_uperm;
		HV* ret_acl_gperm;
		acl_entry_t ent;
		acl_t acl;
		int ret;
		acl = acl_get_file(filename, acl_types[i]);
		if (acl == NULL) {
			continue;
		}

		ret = acl_get_entry(acl, ACL_FIRST_ENTRY, &ent);
		if (ret != 1){
			continue;
		}

		acl_hash = newHV();
		ret_acl_uperm = newHV();
		ret_acl_gperm = newHV();
		
		while (ret > 0) {
			acl_tag_t e_type;
			acl_get_tag_type(ent, &e_type);
			char id_str[30];	//Enough to print uint64_t
			U32 id_str_len;
			id_t *id_p;

			switch(e_type) {
				case ACL_USER_OBJ:	add_to_hash(acl_hash, &ent, USER_OBJ_KEY,  USER_OBJ_KEY_LENGTH);	break;
				case ACL_GROUP_OBJ:	add_to_hash(acl_hash, &ent, GROUP_OBJ_KEY, GROUP_OBJ_KEY_LENGTH);	break;
				case ACL_MASK:		add_to_hash(acl_hash, &ent, MASK_KEY,      MASK_KEY_LENGTH);	break;
				case ACL_OTHER:		add_to_hash(acl_hash, &ent, OTHER_KEY,     OTHER_KEY_LENGTH);	break;
				case ACL_USER:
					id_p = acl_get_qualifier(ent);
					id_str_len = sprintf(id_str, "%d", *id_p);
					add_to_hash(ret_acl_uperm, &ent, id_str, id_str_len);
					break;
				case ACL_GROUP:
					id_p = acl_get_qualifier(ent);
					id_str_len = sprintf(id_str, "%d", *id_p);
					add_to_hash(ret_acl_gperm, &ent, id_str, id_str_len);
					break;
			}
			ret = acl_get_entry(acl, ACL_NEXT_ENTRY, &ent);
		}
		hv_store(acl_hash, USER_KEY,  USER_KEY_LENGTH,  newRV_noinc((SV*) ret_acl_uperm), 0);
		hv_store(acl_hash, GROUP_KEY, GROUP_KEY_LENGTH, newRV_noinc((SV*) ret_acl_gperm), 0);
		*(acl_hashes[i]) = acl_hash;
	}
	if(NULL==*out_acl && NULL==*out_default_acl){
		*out_acl = newHV();
		add_perm_to_hash(*out_acl, st.st_mode && S_IRUSR, st.st_mode && S_IWUSR, st.st_mode && S_IXUSR, USER_OBJ_KEY,  USER_OBJ_KEY_LENGTH);
		add_perm_to_hash(*out_acl, st.st_mode && S_IRGRP, st.st_mode && S_IWGRP, st.st_mode && S_IXGRP, GROUP_OBJ_KEY, GROUP_OBJ_KEY_LENGTH);
		add_perm_to_hash(*out_acl, st.st_mode && S_IROTH, st.st_mode && S_IWOTH, st.st_mode && S_IXOTH, OTHER_KEY,     OTHER_KEY_LENGTH);
	}

	return (NULL==*out_acl)?0:( (NULL==*out_default_acl)?1:2 );
}

int setfacl_internal(char *filename, HV *in_acl_hash, HV *in_default_acl_hash){
	HV         *acl_hashes[3] = {in_acl_hash,     in_default_acl_hash, NULL};
	acl_type_t acl_types[3]   = {ACL_TYPE_ACCESS, ACL_TYPE_DEFAULT,    0};
	int i = 0;
	int rc = CONSTANT_YES;

	while(NULL != acl_hashes[i]){
		acl_t acl = NULL;
		acl_entry_t ent;
		HE *hash_entry;
		SV **hash_ref;
		HV *user_hash  = NULL;
		HV *group_hash = NULL;
		HV *current_acl = acl_hashes[i];

		if(hash_ref = hv_fetch(current_acl, USER_KEY, USER_KEY_LENGTH, 0)){
			user_hash = derefHV(*hash_ref);
		}else{
			//missing USER_KEY
		}

		if(hash_ref = hv_fetch(current_acl, GROUP_KEY, GROUP_KEY_LENGTH, 0)){
			group_hash = derefHV(*hash_ref);
		}else{
			//missing GROUP_KEY
		}

		acl = acl_init(0);
		if (!acl) {
			rc = CONSTANT_NO;
		}
		if (acl_create_entry(&acl, &ent) == 0){
			acl_set_tag_type(ent, ACL_USER_OBJ);
			set_perm(ent, get_perm_from_hash(current_acl, USER_OBJ_KEY, USER_OBJ_KEY_LENGTH));
		} else {
			rc = CONSTANT_NO;
		}
		if (acl_create_entry(&acl, &ent) == 0){
			acl_set_tag_type(ent, ACL_GROUP_OBJ);
			set_perm(ent, get_perm_from_hash(current_acl, GROUP_OBJ_KEY, GROUP_OBJ_KEY_LENGTH));
		} else {
			rc = CONSTANT_NO;
		}
		if (acl_create_entry(&acl, &ent) == 0){
			acl_set_tag_type(ent, ACL_MASK);
			set_perm(ent, get_perm_from_hash(current_acl, MASK_KEY, MASK_KEY_LENGTH));
		} else {
			rc = CONSTANT_NO;
		}
		if (acl_create_entry(&acl, &ent) == 0){
			acl_set_tag_type(ent, ACL_OTHER);
			set_perm(ent, get_perm_from_hash(current_acl, OTHER_KEY, OTHER_KEY_LENGTH));
		} else {
			rc = CONSTANT_NO;
		}
	
		if(NULL != user_hash){
			hv_iterinit(user_hash);
			while(hash_entry = hv_iternext(user_hash)){
				id_t id_p;
				I32 key_len;
				char *key = hv_iterkey(hash_entry, &key_len);
				id_p = atoi(key);
				if (acl_create_entry(&acl, &ent) == 0){
					acl_set_tag_type(ent, ACL_USER);
					acl_set_qualifier(ent, &id_p);
					set_perm(ent, get_perm_from_hash(user_hash, key, key_len));
				} else {
					rc = CONSTANT_NO;
				}
			}
		}

		if(NULL != group_hash){
			hv_iterinit(group_hash);
			while(hash_entry = hv_iternext(group_hash)){
				id_t id_p;
				I32 key_len;
				char *key = hv_iterkey(hash_entry, &key_len);
				id_p = atoi(key);
				if (acl_create_entry(&acl, &ent) == 0){
					acl_set_tag_type(ent, ACL_GROUP);
					acl_set_qualifier(ent, &id_p);
					set_perm(ent, get_perm_from_hash(group_hash, key, key_len));
				} else {
					rc = CONSTANT_NO;
				}
			}
		}

		if (acl_set_file(filename, acl_types[i], acl) == -1) {
			rc = CONSTANT_NO;
		}

		acl_free(acl);

		i++;
	}

	return rc;
}

/*
 * Exported code
 */

#define PACKAGE_NAME "Linux::ACL"

#line 304 "ACL.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 448 "ACL.c"

XS_EUPXS(XS_Linux__ACL_getfacl); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__ACL_getfacl)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "filename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	filename = ST(0)
;
#line 300 "ACL.xs"
		HV *acl, *default_acl;
		STRLEN filename_string_length;
		char *filename_string = SvPV(filename, filename_string_length);

		int count = getfacl_internal(filename_string, &acl, &default_acl);

		if(count>=1)
			XPUSHs(  sv_2mortal( newRV_noinc((SV*) acl) )  );
		if(count>=2)
			XPUSHs(  sv_2mortal( newRV_noinc((SV*) default_acl) )  );
		XSRETURN(count);
#line 473 "ACL.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Linux__ACL_setfacl); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__ACL_setfacl)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "filename, acl_hashref, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	filename = ST(0)
;
	SV *	acl_hashref = ST(1)
;
#line 318 "ACL.xs"
		STRLEN filename_string_length;
		char* filename_string = SvPV(filename, filename_string_length);
		HV *acl_hash         = derefHV(acl_hashref);
		HV *default_acl_hash = NULL;
		if( items > 2 )
			default_acl_hash = derefHV(ST(2));

		if(NULL == acl_hash){
			XSRETURN_NO;
		}

		if( CONSTANT_YES == setfacl_internal(filename_string, acl_hash, default_acl_hash) ){
			XSRETURN_YES;
		}else{
			XSRETURN_NO;
		}
#line 510 "ACL.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Linux__ACL); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Linux__ACL)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Linux::ACL::getfacl", XS_Linux__ACL_getfacl);
        newXS_deffile("Linux::ACL::setfacl", XS_Linux__ACL_setfacl);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

